#include "util.h"

#ifndef lint
char copyright[] =
"CONVERT_INDIV - Version "VERSION"\nCopyright (c) 1995 Brian A. Lantz. All rights reserved.\n";
#endif /* not lint */


char *getargp;

char *getarg(char *line);


char *getarg(char *line)
{
char *arg;

	if (line)
		getargp = line;
	arg = getargp;
	while (*getargp && *getargp != '|') {
		getargp++;
	}
	if (*getargp)
		*getargp++ = '\0';
	return arg;
}

int
main (void)
{
long total = 0, skipped = 0;
FILE *fp;
GDBM_FILE db;
datum key_data, data_data, return_data;
struct appl_dat ap;
char buffer[1024];
char callsign[2048];

	if ((fp = fopen(_PATH_INDIV_FILE, "r")) == NULLFILE)	{
		printf ("Error #%d opening file %s\n", errno, _PATH_INDIV_FILE);
		return 0;
	}
	db = gdbm_open (_PATH_DATABASE, 0, GDBM_WRCREAT | GDBM_FAST, 00664, NULL);
	if (db == NULL)	{
		printf ("Error setting up gdbm file: %s\n", gdbm_strerror(gdbm_errno));
		return 0;
	}
	while (!feof(fp))	{
		fgets (buffer, 1024, fp);
		if (feof(fp))
			continue;
		getargp = buffer;
		strcpy (callsign, getarg(0));
		key_data.dptr = callsign;
		key_data.dsize = strlen(callsign) + 1;

		return_data = gdbm_fetch (db, key_data);
		if (return_data.dptr != NULL)	{
			(void) unsqueeze (&ap, return_data.dptr);
			free (return_data.dptr);
		} else	{
			memset (ap.name_licensee, ' ', 40);
			memset (ap.callsign_prev, ' ', 10);
			memset (ap.text_street, ' ', 35);
			memset (ap.text_pobox, ' ', 20);
			memset (ap.city, ' ', 20);
			memset (ap.state, ' ', 2);
			memset (ap.zipcode, ' ', 9);
			ap.name_licensee[0] = ap.text_street[0] = 0;
			ap.text_pobox[0] = ap.city[0] = 0;
			ap.state[0] = ap.zipcode[0] = 0;
			ap.date_of_birth = ap.date_issue = 0;
			ap.date_expire = ap.date_last_change = 0;
		}
		/* discard id_fee_data */
		(void) getarg(0);
		/* discard callsign_group */
		(void) getarg(0);

		memset (ap.callsign_prev, ' ', 10);
		strcpy (ap.callsign_prev, getarg(0));
		ap.type_op_class = *(getarg(0));

		/* discard flag_nepa */
		(void) getarg(0);

		ap.type_prev_op_class = *(getarg(0));

		data_data.dsize = squeeze (&ap, buffer);
		data_data.dptr = buffer;
		total++;
		if (gdbm_store (db, key_data, data_data, GDBM_REPLACE) != 0)	{
			printf ("Error: Item %s not inserted\n", callsign);
			skipped++;
		} else
			printf ("Adding information for %s\n", callsign);
	}
	printf ("Complete! There were %ld entries added - %ld skipped\n", total - skipped, skipped);
	gdbm_close (db);
	return (0);
}

